#!/usr/bin/perl -w
#
# C.J.Keene
# May 2007
# run analog for each eprint record.
#
#
use DBI;

# open database for recording
$db="foobareprints";
$host="localhost";
$userid="foo";
$passwd="bar";
$connectionInfo="dbi:mysql:$db;$host";

#####################################################
# Functions
# ###################################################
#
# checksize ($string_to_check, $string_to_reduce)
sub checksize {
	$fullstring = $_[0];
	$chop_me = $_[1];
	if (length $fullstring > 254) {
		#print "bigger than 254 $fullstring\n";
		# find out how big it is
		$size = length $fullstring;
		# and now find how many chars we have to remove
		# we remove 260 some we have some spare chars for the '...'
		$reducesize = $size - 250;
		# we can't just chop the complete string as it may produce
		# an invalid command line (missing double quote etc)
		# so we need to remove the characters from the doctitle 
		# string.
		$size2 = length $chop_me;
		$chop_me_new_length = $size2 - $reducesize;
		$chop_me = substr($chop_me, 0, $chop_me_new_length);
		# now rebuild the full string
		# This is awful, i should be shot
		# modify the string outside the sub and not return
		# a var, no abstraction. awful
		$doctitle = $chop_me . "...";
		$reqaliasstring = "REQALIAS /" . $docid . "/" . $docfilename;
        	$reqaliasstring .= " \"[$docformat] $doctitle\"";

	} 
}

####################################################



# make connection to database
$dbh = DBI->connect($connectionInfo,$userid,$passwd);



###############################################################
# we want to produce a file for analog, mapping file
# names with article titles
$filenamequery = "SELECT d.docid, d.format, d.main, a.title, 
a.book_title, a.eprintid
        FROM document d, archive a
        WHERE d.eprintid = a.eprintid";

$sth = $dbh->prepare($filenamequery);
$sth->execute();

# assign fields to variables
$sth->bind_columns(\$docid, \$docformat, \$docfilename, \$doctitle, \$btitle, \$eprintid);

# the analog config file to write to
open(REQALIAS, ">eprint_reqalias.cfg") or die;

while($sth->fetch()) {
        # if no title hope there is a book title
        if ($doctitle eq "") {
                $doctitle = $btitle;
        }
        # remove double quotes from the title
        $doctitle =~ s/\"//g;
	# and remove other stuff as well
	$doctitle =~ s/
//g;
	$doctitle =~ s/\*//g;
	$doctitle =~ s/\n//g;
	#$docfilename =~ s/\&/%26/g;

        # change the hyphen in the docid to a slash
        # ie ready to use as a filename
        $docid =~ s/-/\//;
        $reqaliasstring = "REQALIAS /" . $docid . "/" . $docfilename;
        $reqaliasstring .= " \"[$docformat] $doctitle\"";
	#
	# Check string size is below 255 chars
	#$outputstring = checksize($reqaliasstring);
	checksize($reqaliasstring, $doctitle);
	#
        print REQALIAS "$reqaliasstring\n";
}




####################################################
# now do similar for the record views for all eprints
$filenamequery2 = "SELECT a.title, a.book_title, a.eprintid
        FROM archive a";

$sth = $dbh->prepare($filenamequery2);
$sth->execute();

# assign fields to variables
$sth->bind_columns(\$doctitle, \$btitle, \$eprintid);

while($sth->fetch()) {
        if ($doctitle eq "") {
                $doctitle = $btitle;
        }
        # remove double quotes from the title
        $doctitle =~ s/\"//g;
	# and remove other stuff as well
	$doctitle =~ s/
//g;
	$doctitle =~ s/\*//g;
	$doctitle =~ s/\n//g;
	#
        print REQALIAS "REQALIAS \/$eprintid\/ \"[record] $doctitle\"\n";
}

